diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 8859082fb..c4353c224 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -52,7 +52,7 @@ public abstract class PlayerController {
 
 		Block mineBlock = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {
-			float mineStrength = mineBlock.blockStrength(mc.thePlayer);
+			float mineStrength = mineBlock.blockStrength(mc.theWorld, x, y, z, side, mc.thePlayer);
 			
 			if(mineStrength < 1.0f) {
 				if(!repeat) {
@@ -80,7 +80,7 @@ public abstract class PlayerController {
 		if(mineBlock != null) {	
 			syncCurrentPlayItem();
 			
-			float mineStrength = mineBlock.blockStrength(mc.thePlayer);
+			float mineStrength = mineBlock.blockStrength(mc.theWorld, x, y, z, side, mc.thePlayer);
 			if(mineStrength >= 1.0f) {
 				//Instant Mining
 				
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 8eff72ef9..cdaace8af 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -180,6 +180,7 @@ public class BlockModelDispatcher
         addDispatch(new StandardBlockModel<>(Blocks.GRAVEL).withTextures("minecraft:block/gravel"));
 
         addDispatch(new StandardBlockModel<>(Blocks.BEDROCK).withTextures("minecraft:block/bedrock"));
+        addDispatch(new FullRotatableBlockModel<>(Blocks.BONESHALE).withTextures("minecraft:block/bone_shale_top", "minecraft:block/bone_shale_bottom", "minecraft:block/bone_shale_side"));
 
         addDispatch(new FluidBlockModel<>(Blocks.FLUID_WATER_FLOWING).withTextures("minecraft:block/water_still", "minecraft:block/water_flowing", "minecraft:block/water_flowing"));
         addDispatch(new FluidBlockModel<>(Blocks.FLUID_WATER_STILL).withTextures("minecraft:block/water_still", "minecraft:block/water_flowing"));
@@ -425,6 +426,8 @@ public class BlockModelDispatcher
         addDispatch(new StairsBlockModel<>(Blocks.STAIRS_BRICK_NETHERRACK));
 
         addDispatch(new StandardBlockModel<>(Blocks.SOULSAND).withTextures("minecraft:block/soulsand"));
+        addDispatch(new StandardBlockModel<>(Blocks.SOULSCHIST).withTextures("minecraft:block/soulschist"));
+
         addDispatch(new StandardBlockModel<>(Blocks.GLOWSTONE).withTextures("minecraft:block/glowstone"));
 
         addDispatch(new PortalBlockModel<>(Blocks.PORTAL_NETHER).withTextures("minecraft:block/portal_nether"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java
new file mode 100644
index 000000000..19ccd91f9
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java
@@ -0,0 +1,76 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FullRotatableBlock;
+import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
+
+public class FullRotatableBlockModel<T extends FullRotatableBlock> extends StandardBlockModel<T> {
+    public FullRotatableBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        final Direction dir = FullRotatableBlock.metaToDirection(meta);
+
+        switch (dir) {
+            case DOWN:
+                renderBlocks.uvRotateEast = 3;
+                renderBlocks.uvRotateWest = 3;
+                renderBlocks.uvRotateSouth = 3;
+                renderBlocks.uvRotateNorth = 3;
+                break;
+
+            case NORTH:
+                renderBlocks.uvRotateSouth = 1;
+                renderBlocks.uvRotateNorth = 2;
+                break;
+
+            case SOUTH:
+                renderBlocks.uvRotateSouth = 2;
+                renderBlocks.uvRotateNorth = 1;
+                renderBlocks.uvRotateTop = 3;
+                renderBlocks.uvRotateBottom = 3;
+                break;
+
+            case WEST:
+                renderBlocks.uvRotateEast = 1;
+                renderBlocks.uvRotateWest = 2;
+                renderBlocks.uvRotateTop = 2;
+                renderBlocks.uvRotateBottom = 1;
+                break;
+
+            case EAST:
+                renderBlocks.uvRotateEast = 2;
+                renderBlocks.uvRotateWest = 1;
+                renderBlocks.uvRotateTop = 1;
+                renderBlocks.uvRotateBottom = 2;
+                break;
+        }
+        final boolean result = renderStandardBlock(tessellator, block, x, y, z);
+        resetRenderBlocks();
+
+        return result;
+    }
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, 1, brightness, alpha, lightmapCoordinate);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        final Direction dir = FullRotatableBlock.metaToDirection(data);
+        if (side == dir.getSide()) {
+            return atlasIndices[Side.TOP.getId()];
+        }
+        return side.getId() != PistonDirections.directionMap[dir.getId()] ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
index 0aefb478a..ca04ca569 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
@@ -30,13 +30,13 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
         renderBlocks.renderAllFaces = false;
         return result;
     }
-    protected boolean renderPistonBase(Tessellator tessellator, int i, int j, int k, boolean flag) {
-        int l = renderBlocks.blockAccess.getBlockMetadata(i, j, k);
-        boolean flag1 = flag || (l & 8) != 0;
-        int i1 = BasePistonBlock.getDirection(l);
-        if(flag1)
+    protected boolean renderPistonBase(Tessellator tessellator, int x, int y, int z, boolean noCulling) {
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        boolean extended = noCulling || (meta & 8) != 0;
+        int direction = BasePistonBlock.getDirection(meta);
+        if(extended)
         {
-            switch(i1)
+            switch(direction)
             {
                 case 0: // '\0'
                     renderBlocks.uvRotateEast = 3;
@@ -80,12 +80,12 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
                     block.setBlockBounds(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
                     break;
             }
-            renderStandardBlock(tessellator, block, i, j, k);
+            renderStandardBlock(tessellator, block, x, y, z);
             resetRenderBlocks();
             block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         } else
         {
-            switch(i1)
+            switch(direction)
             {
                 case 0: // '\0'
                     renderBlocks.uvRotateEast = 3;
@@ -120,7 +120,7 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
                     renderBlocks.uvRotateBottom = 2;
                     break;
             }
-            renderStandardBlock(tessellator, block, i, j, k);
+            renderStandardBlock(tessellator, block, x, y, z);
             resetRenderBlocks();
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 8ec497308..26431f3ac 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -416,21 +416,18 @@ public class Block
 
     }
 
-    public boolean renderFullbright()
-    {
-        return false;
-    }
-
-    public float blockStrength(Player player)
+    public float blockStrength(World world, int x, int y, int z, Side side, Player player)
     {
         if(blockHardness < 0.0F)
         {
             return 0.0F;
         }
-        if(!player.canHarvestBlock(this))
+
+        if (!player.canHarvestBlock(this))
         {
             return 1.0F / blockHardness / 100F;
-        } else
+        }
+        else
         {
             return player.getCurrentPlayerStrVsBlock(this) / blockHardness / 30F;
         }
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 92b38f0d2..794eba74b 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -164,6 +164,7 @@ public final class Blocks {
     public static Block GRAVEL;
 
     public static Block BEDROCK;
+    public static Block BONESHALE;
 
     public static Block FLUID_WATER_FLOWING;
     public static Block FLUID_WATER_STILL;
@@ -404,6 +405,7 @@ public final class Blocks {
     public static Block STAIRS_BRICK_NETHERRACK;
 
     public static Block SOULSAND;
+    public static Block SOULSCHIST;
 
     public static Block GLOWSTONE;
 
@@ -722,6 +724,8 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_SHOVEL);
 
         BEDROCK = new BedrockBlock("bedrock", "minecraft:block/bedrock", 260, Material.stone).withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F);
+        BONESHALE = new BoneShaleBlock("boneshale", "minecraft:block/boneshale", 261, Material.stone).withSound(BlockSounds.STONE).withHardness(16F).withBlastResistance(6000000F).withImmovableFlagSet()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         FLUID_WATER_FLOWING = new FlowingFluidBlock("fluid.water.flowing", "minecraft:block/fluid_water_flowing", 270, Material.water).withHardness(100F).withLightBlock(3).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
             .withTags(BlockTags.IS_WATER, BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU);
@@ -1129,13 +1133,13 @@ public final class Blocks {
 
 
         COBBLE_NETHERRACK = new Block("cobble.netherrack", "minecraft:block/cobble_netherrack", 800, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH);
         COBBLE_NETHERRACK_IGNEOUS = new Block("cobble.netherrack.igneous", "minecraft:block/cobble_netherrack_igneous", 801, Material.netherrack).withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         COBBLE_NETHERRACK_MOSSY = new Block("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
         NETHERRACK = new Block("netherrack", "minecraft:block/netherrack", 803, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.32F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH);
         BRICK_NETHERRACK = new Block("brick.netherrack", "minecraft:block/brick_netherrack", 804, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         SLAB_NETHERRACK_POLISHED = new SlabBlock(NETHERRACK_CARVED, "minecraft:block/slab_netherrack_polished", 805).withSound(BlockSounds.STONE).withHardness(0.4F)
@@ -1150,7 +1154,9 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         SOULSAND = new SoulSandBlock("soulsand", "minecraft:block/soulsand", 810).withSound(BlockSounds.SAND).withHardness(0.5F).withOverrideColor(MaterialColor.paintedBrown)
-            .withTags(BlockTags.MINEABLE_BY_SHOVEL);
+            .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH);
+        SOULSCHIST = new Block("soulschist", "minecraft:block/soulschist", 811, Material.stone).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.paintedBrown)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         GLOWSTONE = new GlowStoneBlock("glowstone", "minecraft:block/glowstone", 820, Material.stone).withSound(BlockSounds.GLASS).withHardness(0.3F).withLightEmission(1.0F).withOverrideColor(MaterialColor.paintedYellow)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
diff --git a/src/main/java/net/minecraft/core/block/BoneShaleBlock.java b/src/main/java/net/minecraft/core/block/BoneShaleBlock.java
new file mode 100644
index 000000000..5a238ebcf
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BoneShaleBlock.java
@@ -0,0 +1,32 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class BoneShaleBlock extends FullRotatableBlock {
+    public BoneShaleBlock(String translationKey, String namespaceId, int id, Material material) {
+        super(translationKey, namespaceId, id, material);
+    }
+
+    @Override
+    public float blockStrength(World world, int x, int y, int z, Side side, Player player) {
+        float blockHardness = this.blockHardness;
+        final int meta = world.getBlockMetadata(x, y, z);
+        final Direction direction = FullRotatableBlock.metaToDirection(meta);
+        if (side != direction.getSide()) {
+            blockHardness *= 66.6f;
+        }
+
+        if (!player.canHarvestBlock(this))
+        {
+            return 1.0F / blockHardness / 30F;
+        }
+        else
+        {
+            return player.getCurrentPlayerStrVsBlock(this) / blockHardness / 30F;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
new file mode 100644
index 000000000..4488c5f3e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public abstract class FullRotatableBlock extends Block {
+    public FullRotatableBlock(String translationKey, String namespaceId, int id, Material material) {
+        super(translationKey, namespaceId, id, material);
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        final Direction direction = mob.getPlacementDirection(side).getOpposite();
+
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+    }
+
+    public static int directionToMeta(Direction direction) {
+        return direction.getId() & 7;
+    }
+
+    public static Direction metaToDirection(int meta) {
+        return Direction.getDirectionById(meta & 7);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/RotatableBlock.java b/src/main/java/net/minecraft/core/block/RotatableBlock.java
index ce6f92075..c48a984e8 100644
--- a/src/main/java/net/minecraft/core/block/RotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableBlock.java
@@ -10,34 +10,34 @@ public abstract class RotatableBlock extends Block{
         super(key, namespaceId, id, material);
     }
 
-    public void setDefaultDirection(World world, int i, int j, int k)
+    public void setDefaultDirection(World world, int x, int y, int z)
     {
         if(world.isClientSide)
         {
             return;
         }
-        int l = world.getBlockId(i, j, k - 1);
-        int i1 = world.getBlockId(i, j, k + 1);
-        int j1 = world.getBlockId(i - 1, j, k);
-        int k1 = world.getBlockId(i + 1, j, k);
+        int idNegZ = world.getBlockId(x, y, z - 1);
+        int idPosZ = world.getBlockId(x, y, z + 1);
+        int idNegX = world.getBlockId(x - 1, y, z);
+        int idPosX = world.getBlockId(x + 1, y, z);
         byte byte0 = 3;
-        if(Block.solid[l] && !Block.solid[i1])
+        if(Block.solid[idNegZ] && !Block.solid[idPosZ])
         {
             byte0 = 3;
         }
-        if(Block.solid[i1] && !Block.solid[l])
+        if(Block.solid[idPosZ] && !Block.solid[idNegZ])
         {
             byte0 = 2;
         }
-        if(Block.solid[j1] && !Block.solid[k1])
+        if(Block.solid[idNegX] && !Block.solid[idPosX])
         {
             byte0 = 5;
         }
-        if(Block.solid[k1] && !Block.solid[j1])
+        if(Block.solid[idPosX] && !Block.solid[idNegX])
         {
             byte0 = 4;
         }
-        world.setBlockMetadataWithNotify(i, j, k, byte0);
+        world.setBlockMetadataWithNotify(x, y, z, byte0);
     }
 
     public static int getOrientation(int i)
diff --git a/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index bbe98ef7c..aa2f3593b 100644
--- a/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block.tag;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.CactusBlock;
 import net.minecraft.core.block.ChainlinkFenceBlock;
@@ -22,6 +21,7 @@ import net.minecraft.core.item.tool.HoeToolItem;
 import net.minecraft.core.item.tool.PickaxeToolItem;
 import net.minecraft.core.item.tool.ShovelToolItem;
 import net.minecraft.core.item.tool.SwordToolItem;
+import net.minecraft.core.world.generate.CavesLargeFeature;
 import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
@@ -116,11 +116,11 @@ public abstract class BlockTags
      */
     public static Tag<Block> SKATEABLE = Tag.of("skateable");
     /**
-     * Detects grass surface blocks so that {@link net.minecraft.core.world.generate.MapGenCaves MapGenCaves} can replace any exposed dirt with grass once it has finished generating a surface cave.
+     * Detects grass surface blocks so that {@link CavesLargeFeature MapGenCaves} can replace any exposed dirt with grass once it has finished generating a surface cave.
      */
     public static Tag<Block> CAVE_GEN_REPLACES_SURFACE = Tag.of("cave_gen_replaces_surface");
     /**
-     * Determines which blocks {@link net.minecraft.core.world.generate.MapGenCaves MapGenCaves} can cut through
+     * Determines which blocks {@link CavesLargeFeature MapGenCaves} can cut through
      */
     public static Tag<Block> CAVES_CUT_THROUGH = Tag.of("caves_cut_through");
     /**
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index b474f0da8..e5eca2bcb 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -215,7 +215,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     	return true;
     }
 
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int removedBlockId, int x, int y, int z, Side side, Mob entityliving)
+    public boolean onBlockDestroyed(World world, ItemStack itemstack, int removedBlockId, int x, int y, int z, Side side, Mob mob)
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
index 293c65566..26b47034b 100644
--- a/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
@@ -67,21 +67,21 @@ public class HoeToolItem extends ToolItem
     }
     
     @Override
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, Mob entity) {
-    	if(entity != null && !entity.world.isClientSide) {
+    public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, Mob mob) {
+    	if(mob != null && !mob.world.isClientSide) {
         	if(id == Blocks.TALLGRASS.id || id == Blocks.TALLGRASS_FERN.id) {
         		if(this.material.isSilkTouch()) {
-        			entity.world.dropItem(x, y, z, new ItemStack(Item.itemsList[id]));
-            		itemstack.damageItem(1, entity);
+        			mob.world.dropItem(x, y, z, new ItemStack(Item.itemsList[id]));
+            		itemstack.damageItem(1, mob);
         		}else {
-        			if(entity.world.rand.nextInt(4) == 0) {
-            			entity.world.dropItem(x, y, z, new ItemStack(Items.SEEDS_WHEAT));
-                		itemstack.damageItem(1, entity);	
+        			if(mob.world.rand.nextInt(4) == 0) {
+            			mob.world.dropItem(x, y, z, new ItemStack(Items.SEEDS_WHEAT));
+                		itemstack.damageItem(1, mob);
         			}
         		}
         	}
     	}
-    	return super.onBlockDestroyed(world, itemstack, id, x, y, z, side, entity);
+    	return super.onBlockDestroyed(world, itemstack, id, x, y, z, side, mob);
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
index edfc7c33c..b71675049 100644
--- a/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
@@ -41,12 +41,12 @@ public class SwordToolItem extends Item
     }
 
     @Override
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, Mob entityliving)
+    public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob)
     {
         Block block = Block.blocksList[i];
         if(block != null) {
             if(block.getHardness() > 0.0f || isSilkTouch()) {
-                itemstack.damageItem(2, entityliving);
+                itemstack.damageItem(2, mob);
             }
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/item/tool/ToolItem.java b/src/main/java/net/minecraft/core/item/tool/ToolItem.java
index 9e6f61d77..36cd267a3 100644
--- a/src/main/java/net/minecraft/core/item/tool/ToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/ToolItem.java
@@ -45,11 +45,11 @@ public class ToolItem extends Item
 	}
 
 	@Override
-	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int j, int k, int l, Side side, Mob entityliving) {
+	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob) {
 		Block block = Block.blocksList[i];
 		if(block != null) {
 			if(block.getHardness() > 0.0f || isSilkTouch()) {
-				itemstack.damageItem(1, entityliving);
+				itemstack.damageItem(1, mob);
 			}
 		}
 		return true;
